<?php
/*------------------------------------------------------------------------------------------------------------------------------------------
Sr.No.	Date 			Changed By 		Description
--------------------------------------------------------------------------------------------------------------------------------------------*/
$TruncateErrTableQry = "TRUNCATE TABLE customer_error";
$TET = $pdo->prepare($TruncateErrTableQry);
$TET->execute();

$TruncateErr1TableQry = "TRUNCATE TABLE customer_tmp";
$TET1 = $pdo->prepare($TruncateErr1TableQry);
$TET1->execute();

$CSVDataArray=file($TMPFilePath);
$Count=0;
$ErrorLogArray=[];

$LogInRegionRecID=$LogInTerritoryRecID=$LogInRegionTerritoryHQRecID=0;


foreach($CSVDataArray as $filearray)
{
	$Count++;
}
$CountRows = $Count-1;

function InsertError($CustomerTmpRecID,$CSVRowNo,$Error,$LoggedInUser)
{
	$pdo = Database::connect();
	$InsertError = "INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
						VALUES(:CustomerTmpRecID,:CSVRowNo,:Error,:UserRecID)";
	$IE = $pdo->prepare($InsertError);
	$IE->bindValue('CustomerTmpRecID',$CustomerTmpRecID);
	$IE->bindValue('CSVRowNo',$CSVRowNo);
	$IE->bindValue('Error',$Error);
	$IE->bindValue('UserRecID',$LoggedInUser);
	$IE->execute();
}

function DownloadErrorFile()
{
	$pdo = Database::connect();
	$SelectError = "SELECT CSVRowNo AS 'ROW NO.',Error AS 'ERROR'
						FROM customer_error";
	$SE = $pdo->prepare($SelectError);
	$SE->execute();
	
	$SelectErrorCount = "SELECT Count(*) AS ErrorCount FROM customer_error";
	$SErr = $pdo->prepare($SelectErrorCount);
	$SErr->execute();
	$SErrDS	= $SErr->fetch();
	$SErowCount 	= $SErrDS['ErrorCount'];
	$SEcolumnCount 	= 2;
	
	$output='';
	$output.=',';
	$output.="ERROR LOG";
	$output.="\n\n";
	
	// Get The Field Name
	$output .="SR.NO.,";
	for ($i = 0; $i < $SEcolumnCount; $i++)
	{
		$heading = $SE->getColumnMeta($i);
		$output .= '"'.$heading['name'].'",';
	}
	$output .="\n";
	
	// Get Records from the table
	for($j=0; $j<$SErowCount; $j++)
	{
		$output.=($j+1).",";
		$row = $SE->fetch();												   										   
		for ($i = 0; $i < $SEcolumnCount; $i++) 
		{
			if(($i==0) && ($row["$i"]==0))//row no
			{
				$output .=' - ,';
			}
			else
			{
				$output .='"'.$row["$i"].'",';
			}	
		}
		$output .="\n";	
	}
	
	$datetime=date("Y-m-d His");	
	//Generate CSV file											 
	$filename = "Customer_Error_Log".$datetime.".csv";
	file_put_contents("../../UPLOADS/Customer/ERROR_LOGS/" . $filename,$output);
	$FilePath1='../../UPLOADS/Customer/ERROR_LOGS/'.$filename;
	header("Location:$FilePath1");
	unlink($TMPFilePath);
}

$CheckOtherErr 	= 1;
$EachLine 		= $CSVDataArray[0];
$Arr			= explode(",",$EachLine);
$numcols 		= count($Arr); //Header Row

if($numcols!=4)
{
	$CheckOtherErr 			= 0;
	$CustomerTmpRecID 		= '0';
	$CSVRowNo 				= '-';
	$Error 					= 'Invalid No. Of Columns';
	InsertError($CustomerTmpRecID,$CSVRowNo,$Error,$LoggedInUser);
	
	DownloadErrorFile();
}


if($CheckOtherErr==1)
{
	foreach($CSVDataArray as $EachLine)//Check this before adding or deleting columns in csv file.
	{ 
		list($CustomerName[],$Region[],$Territory[],$Headquarter[]) = explode(",",$EachLine);
	}

	
	if(strtoupper(trim($CustomerName[0]))!=strtoupper('CustomerName') || strtoupper(trim($Region[0]))!=strtoupper('Region') || strtoupper(trim($Territory[0]))!=strtoupper('Territory') || strtoupper(trim($Headquarter[0]))!=strtoupper('Headquarter'))
	{
		$CustomerTmpRecID 		= '0';
		$CSVRowNo 				= '1';
		$Error 					= 'Invalid Column Header';
		InsertError($CustomerTmpRecID,$CSVRowNo,$Error,$LoggedInUser);
	}
	
	
	//Less than 2 rows present
	if($CountRows<1)
	{
		$CustomerTmpRecID 		= '0';
		$CSVRowNo 				= '0';
		$Error 					= 'No Records Present';
		InsertError($CustomerTmpRecID,$CSVRowNo,$Error,$LoggedInUser);
	}
}

//*************************************************************
//Check for errors
$CheckErrors = "SELECT COUNT(*) AS CountErr FROM customer_error";
$CE = $pdo->prepare($CheckErrors);
$CE->execute();
$CEDS		= $CE->fetch();
$CECount 	= $CEDS['CountErr'];

if($CECount>0)//1st If start
{
	DownloadErrorFile();
}
else //1st else If
{
	//CSV data is correct. 
	$TruncateErrTableQry = "TRUNCATE TABLE customer_error";
	$TET = $pdo->prepare($TruncateErrTableQry);
	$TET->execute();
	
	//Insert data into dummy table for validations
	$csv_file = $TMPFilePath;
	
	$CsvFilepath = $filelocation.$NextPgUpPath;
	$UploadDataQueryTxt = "SET @position :=1; 
						   LOAD DATA LOCAL INFILE '$CsvFilepath' INTO TABLE customer_tmp		
							   FIELDS TERMINATED BY ',' 
							   OPTIONALLY ENCLOSED BY '\"'
							   LINES TERMINATED BY '\r\n' 							   
							   IGNORE 1 LINES(CustomerName,Region,Territory,Headquarter)
							   SET RowNo = (@position := @position + 1),CSVFilePath=:FilePath,UserRecID=:UserRecID";
	
			
	$seq = $pdo->prepare($UploadDataQueryTxt);
	$seq->bindValue('FilePath',$NextPgUpPath);
	$seq->bindValue('UserRecID',$LoggedInUser);
	$seq->execute();
	$seq->closeCursor();
	
	$CurrDate = date('Y-m-d');
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	//Check loggedin users region,territory,HQ and applicability.
	$CheckLoggedInUserDetails = $pdo->prepare("SELECT DesignationRecID,RegionApplicable,TerritoryApplicable,HeadquarterApplicable,
													RegionRecID,TerritoryRecID,RegionTerritoryHQRecID
													FROM user u 
													LEFT JOIN employee e ON e.RecID=u.EmployeeRecID
													LEFT JOIN designation d ON d.RecID=e.DesignationRecID
													WHERE u.RecID=:loggedInUser");
	$CheckLoggedInUserDetails->bindValue('loggedInUser',$LoggedInUser);
	$CheckLoggedInUserDetails->execute();
	$CheckLoggedInUserDetailsDS 	= $CheckLoggedInUserDetails->fetch();
	$LogInDesignationRecID			= $CheckLoggedInUserDetailsDS['DesignationRecID'];
	$LogInRegionApplicable			= $CheckLoggedInUserDetailsDS['RegionApplicable'];
	$LogInTerritoryApplicable		= $CheckLoggedInUserDetailsDS['TerritoryApplicable'];
	$LogInHeadquarterApplicable		= $CheckLoggedInUserDetailsDS['HeadquarterApplicable'];
	$LogInRegionRecID				= $CheckLoggedInUserDetailsDS['RegionRecID'];
	$LogInTerritoryRecID			= $CheckLoggedInUserDetailsDS['TerritoryRecID'];
	$LogInRegionTerritoryHQRecID	= $CheckLoggedInUserDetailsDS['RegionTerritoryHQRecID'];
	
	 
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//Check Validation
	//1. Customer Name
	//a). Mandatory
	$CheckCustomerNameIfBlank = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
													SELECT RecID,RowNo,'Customer Name is blank',UserRecID
													FROM customer_tmp
													WHERE CustomerName=''");
	$CheckCustomerNameIfBlank->execute();
	
	//b) Input Char
	$CheckCustomerNameInputChar = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
													SELECT RecID,RowNo,'Only alphabets, numbers and special characters allowed in Customer Name',UserRecID
													FROM customer_tmp
													WHERE CustomerName!='' AND CustomerName NOT REGEXP '^[a-zA-Z0-9 --./_@:();]*$'");
	$CheckCustomerNameInputChar->execute();
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//2. Region
	//a). Mandatory
	$CheckRegionIfBlank = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
											SELECT RecID,RowNo,'Region is blank',UserRecID
											FROM customer_tmp
											WHERE Region=''");
	$CheckRegionIfBlank->execute();
	
	//b) Input Char
	$CheckRegionInputChar = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
												SELECT RecID,RowNo,'Only alphabets and numbers allowed in Region',UserRecID
												FROM customer_tmp
												WHERE Region!='' AND Region NOT REGEXP '^[a-zA-Z0-9]*$'");
	$CheckRegionInputChar->execute();
	
	//c) Valid
	$CheckRegionIfInValid = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
												SELECT RecID,RowNo,'Invalid Region',UserRecID
												FROM customer_tmp
												WHERE Region!='' AND Region NOT IN (SELECT RegionName FROM region WHERE Active=1)");
	$CheckRegionIfInValid->execute();
	
	//d) Loggedin users region
	if($LogInRegionApplicable==1)
	{
		$CheckMatchingRegionWithUser = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
															SELECT RecID,RowNo,'Invalid Region for loggedin user',UserRecID
															FROM customer_tmp
															WHERE Region!='' AND Region NOT IN (SELECT RegionName FROM region WHERE RecID=:RegionRecID)");
		$CheckMatchingRegionWithUser->bindValue('RegionRecID',$LogInRegionRecID);
		$CheckMatchingRegionWithUser->execute();
	}
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//3. Territory
	//a). Mandatory
	$CheckTerritoryIfBlank = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
												SELECT RecID,RowNo,'Territory is blank',UserRecID
												FROM customer_tmp
												WHERE Territory=''");
	$CheckTerritoryIfBlank->execute();
	
	//b) Input Char
	$CheckTerritoryInputChar = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
													SELECT RecID,RowNo,'Only alphabets, numbers and /*-+\.()@ characters allowed in Territory',UserRecID
													FROM customer_tmp
													WHERE Territory!='' AND Territory NOT REGEXP '^[a-zA-Z0-9 /*--_+\.()@]*$'");
	$CheckTerritoryInputChar->execute();
	
	//c) Valid
	$CheckTerritoryIfInValid = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
													SELECT RecID,RowNo,'Invalid Territory',UserRecID
													FROM customer_tmp
													WHERE Territory!='' AND Territory NOT IN (SELECT TerritoryName FROM region_territory WHERE Active=1)");
	$CheckTerritoryIfInValid->execute();
	
	//d) Loggedin users territory
	if($LogInTerritoryApplicable==1)
	{
		$CheckMatchingTerritoryWithUser = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
															SELECT RecID,RowNo,'Invalid Territory for loggedin user',UserRecID
															FROM customer_tmp
															WHERE Territory!='' AND Territory NOT IN (SELECT TerritoryName FROM region_territory WHERE RecID=:TerritoryRecID)");
		$CheckMatchingTerritoryWithUser->bindValue('TerritoryRecID',$LogInTerritoryRecID);
		$CheckMatchingTerritoryWithUser->execute();
	}
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//4. Headquarter
	//a). Mandatory
	$CheckHeadquarterIfBlank = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
													SELECT RecID,RowNo,'Headquarter is blank',UserRecID
													FROM customer_tmp
													WHERE Headquarter=''");
	$CheckHeadquarterIfBlank->execute();
	
	//b) Input Char
	$CheckHeadquarterInputChar = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
													SELECT RecID,RowNo,'Only alphabets, numbers and /*-+\.()@ characters allowed in Headquarter',UserRecID
													FROM customer_tmp
													WHERE Headquarter!='' AND Headquarter NOT REGEXP '^[a-zA-Z0-9 /*--_+\.()@]*$'");
	$CheckHeadquarterInputChar->execute();
	
	//c) Valid
	$CheckHeadquarterIfInValid = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
													SELECT RecID,RowNo,'Invalid Headquarter',UserRecID
													FROM customer_tmp
													WHERE Headquarter!='' AND Headquarter NOT IN(SELECT RegionTerritoryHQName FROM region_territory_hq WHERE Active=1)");
	$CheckHeadquarterIfInValid->execute();
	
	//d) Loggedin users Headquarter
	if($LogInHeadquarterApplicable==1)
	{
		$CheckMatchingHeadquarterWithUser = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
															SELECT RecID,RowNo,'Invalid Headquarter for loggedin user',UserRecID
															FROM customer_tmp
															WHERE Headquarter!='' 
															AND Headquarter NOT IN(SELECT RegionTerritoryHQName FROM region_territory_hq WHERE RecID=:HeadquarterRecID)");
		$CheckMatchingHeadquarterWithUser->bindValue('HeadquarterRecID',$LogInRegionTerritoryHQRecID);
		$CheckMatchingHeadquarterWithUser->execute();
	}
	
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//Check if any error exist
	
	$CheckErrors = "SELECT COUNT(*) AS CountErr FROM customer_error";
	$CE = $pdo->prepare($CheckErrors);
	$CE->execute();
	$CEDS		= $CE->fetch();
	$CECount 	= $CEDS['CountErr'];
	
	if($CECount>0)//1st If start
	{
		DownloadErrorFile();
	}
	else 
	{
		//Update Region, Territory and Headquarter RecID
		$UpdateRegionDetails = $pdo->prepare("UPDATE customer_tmp ct
												INNER JOIN 
												(
													SELECT r.RecID AS RRecID,RegionName
														FROM region r WHERE Active=1
												)X ON X.RegionName=ct.Region
												SET ct.TmpRegionRecID=X.RRecID 
												WHERE ct.Region=X.RegionName ");
		$UpdateRegionDetails->execute();
		
		$UpdateTerritoryDetails = $pdo->prepare("UPDATE customer_tmp ct
													INNER JOIN 
													(
														SELECT RecID,RegionRecID,TerritoryName
															FROM region_territory WHERE Active=1
													)X ON X.TerritoryName=ct.Territory
													AND X.RegionRecID=ct.TmpRegionRecID
													SET ct.TmpTerritoryRecID=X.RecID
													WHERE ct.Territory=X.TerritoryName
													AND ct.TmpRegionRecID=X.RegionRecID");
		$UpdateTerritoryDetails->execute();
		
		$UpdateHQDetails = $pdo->prepare("UPDATE customer_tmp ct
												INNER JOIN 
												(
													SELECT RecID,RegionRecID,RegionTerritoryRecID,RegionTerritoryHQName
														FROM region_territory_hq WHERE Active=1
												)X ON X.RegionTerritoryHQName=ct.Headquarter
												AND X.RegionTerritoryRecID=ct.TmpTerritoryRecID
												AND X.RegionRecID=ct.TmpRegionRecID
												SET ct.TmpHeadquarterRecID=X.RecID
												WHERE ct.Headquarter=X.RegionTerritoryHQName
												AND ct.TmpTerritoryRecID=X.RegionTerritoryRecID
												AND ct.TmpRegionRecID=X.RegionRecID");
		$UpdateHQDetails->execute();
		
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------
		//Validation
		//Check valid combination of Region, Territory, Headquarter
		
		//1. Region and Territory combination
		$CheckRegionTerritoryCombo = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
														SELECT DISTINCT ct.RecID,RowNo,'Invalid Territory for Region',UserRecID
														FROM customer_tmp ct,region_territory rt
														WHERE Territory!='' AND ct.TmpTerritoryRecID=0 ");
		$CheckRegionTerritoryCombo->execute();
		
		//2. Region, Territory and Headquarter  
		$CheckRegionTerrHQCombo = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
														SELECT DISTINCT ct.RecID,RowNo,'Invalid Headquarter for Region and Territory',UserRecID
														FROM customer_tmp ct,region_territory_hq rthq
														WHERE Headquarter!='' AND ct.TmpHeadquarterRecID=0 ");
		$CheckRegionTerrHQCombo->execute();
			
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------
		//Check if any error exist
		$CheckErrors = "SELECT COUNT(*) AS CountErr FROM customer_error";
		$CE = $pdo->prepare($CheckErrors);
		$CE->execute();
		$CEDS		= $CE->fetch();
		$CECount 	= $CEDS['CountErr'];
		
		if($CECount>0)//1st If start
		{
			DownloadErrorFile();
		}
		else 
		{
			//Validation
			//Check Unique Customer Name in Region Territory and Headquarter
			//a) Unique in file
			$CheckCustomerNameDuplicateInFile = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
																	SELECT customer_tmp.RecID,customer_tmp.RowNo,
																	'Duplicate Customer Name for Region,Territory,Headquarter',UserRecID
																	FROM customer_tmp
																	INNER JOIN (SELECT RecID,RowNo,CustomerName,Region,Territory,Headquarter
																					FROM customer_tmp
																					GROUP BY CustomerName,Region,Territory,Headquarter
																					HAVING COUNT(*) > 1
																				) dup
																	ON customer_tmp.CustomerName = dup.CustomerName
																	AND customer_tmp.Region = dup.Region
																	AND customer_tmp.Territory = dup.Territory
																	AND customer_tmp.Headquarter = dup.Headquarter
																	WHERE customer_tmp.RowNo NOT IN (SELECT RowNo
																					FROM customer_tmp
																					GROUP BY CustomerName,Region,Territory,Headquarter
																					HAVING COUNT(*) > 1)");
			$CheckCustomerNameDuplicateInFile->execute();
			
			//----------------------------------------------------------------------------------------------------------------------------------------------------------
			//b) Unique in master
			$CheckCustomerNameIfAlreadyPresent = $pdo->prepare("INSERT INTO customer_error(CustomerTmpRecID,CSVRowNo,Error,UserRecID)
																	SELECT ct.RecID,RowNo,'Customer Name already present',UserRecID
																	FROM customer_tmp ct,customer c
																	WHERE ct.CustomerName = c.CustomerName
																	AND ct.TmpRegionRecID = c.RegionRecID
																	AND ct.TmpTerritoryRecID = c.TerritoryRecID
																	AND ct.TmpHeadquarterRecID = c.RegionTerritoryHQRecID");
			$CheckCustomerNameIfAlreadyPresent->execute();
			
			//----------------------------------------------------------------------------------------------------------------------------------------------------------
			//Check if any error exist
			$CheckErrors = "SELECT COUNT(*) AS CountErr FROM customer_error";
			$CE = $pdo->prepare($CheckErrors);
			$CE->execute();
			$CEDS		= $CE->fetch();
			$CECount 	= $CEDS['CountErr'];
			
			if($CECount>0)//1st If start
			{
				DownloadErrorFile();
			}
			else 
			{
				//Insert Into main table
				$CallProcedure = $pdo->prepare("CALL CustomerUploadInsert()");
				$CallProcedure->execute();
				
				header("Location:CustomerUploadSuccess.php");
			}
		}
	}
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
}//Else of 1st If End

?>