<?php
/*------------------------------------------------------------------------------------------------------------------------------------------
Sr.No.	Date 			Changed By 		Description
--------------------------------------------------------------------------------------------------------------------------------------------*/
$TruncateErrTableQry = "TRUNCATE TABLE distributor_error";
$TET = $pdo->prepare($TruncateErrTableQry);
$TET->execute();

$TruncateErr1TableQry = "TRUNCATE TABLE distributor_tmp";
$TET1 = $pdo->prepare($TruncateErr1TableQry);
$TET1->execute();

$CSVDataArray=file($TMPFilePath);
$Count=0;
$ErrorLogArray=[];
foreach($CSVDataArray as $filearray)
{
	$Count++;
}
$CountRows = $Count-1;

function InsertError($DistributorTempRecID,$CSVRowNo,$Error)
{
	$pdo = Database::connect();
	$InsertError = "INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
						VALUES(:DistributorTempRecID,:CSVRowNo,:Error)";
	$IE = $pdo->prepare($InsertError);
	$IE->bindValue('DistributorTempRecID',$DistributorTempRecID);
	$IE->bindValue('CSVRowNo',$CSVRowNo);
	$IE->bindValue('Error',$Error);
	$IE->execute();
}

function DownloadErrorFile()
{
	$pdo = Database::connect();
	$SelectError = "SELECT CSVRowNo AS 'ROW NO.',Error AS 'ERROR'
						FROM distributor_error";
	$SE = $pdo->prepare($SelectError);
	$SE->execute();
	
	$SelectErrorCount = "SELECT Count(*) AS ErrorCount FROM distributor_error";
	$SErr = $pdo->prepare($SelectErrorCount);
	$SErr->execute();
	$SErrDS	= $SErr->fetch();
	$SErowCount 	= $SErrDS['ErrorCount'];
	$SEcolumnCount 	= 2;
	
	$output='';
	$output.=',';
	$output.="ERROR LOG";
	$output.="\n\n";
	
	// Get The Field Name
	$output .="SR.NO.,";
	for ($i = 0; $i < $SEcolumnCount; $i++)
	{
		$heading = $SE->getColumnMeta($i);
		$output .= '"'.$heading['name'].'",';
	}
	$output .="\n";
	
	// Get Records from the table
	for($j=0; $j<$SErowCount; $j++)
	{
		$output.=($j+1).",";
		$row = $SE->fetch();												   										   
		for ($i = 0; $i < $SEcolumnCount; $i++) 
		{
			if(($i==0) && ($row["$i"]==0))//row no
			{
				$output .=' - ,';
			}
			else
			{
				$output .='"'.$row["$i"].'",';
			}	
		}
		$output .="\n";	
	}
	
	$datetime=date("Y-m-d His");	
	//Generate CSV file											 
	$filename = "Distributor_Error_Log".$datetime.".csv";
	file_put_contents("../../UPLOADS/Distributor/ERROR_LOGS/" . $filename,$output);
	$FilePath1='../../UPLOADS/Distributor/ERROR_LOGS/'.$filename;
	header("Location:$FilePath1");
	unlink($TMPFilePath);
}

$CheckOtherErr = 1;
$EachLine 	= $CSVDataArray[0];
$Arr		= explode(",",$EachLine);
$numcols 	= count($Arr); //Header Row

if($numcols!=4)
{
	$CheckOtherErr = 0;
	$DistributorTempRecID 		= '0';
	$CSVRowNo 					= '-';
	$Error 						= 'Invalid No. Of Columns';
	InsertError($DistributorTempRecID,$CSVRowNo,$Error);
	
	DownloadErrorFile();
}


if($CheckOtherErr==1)
{
	foreach($CSVDataArray as $EachLine)//Check this before adding or deleting columns in csv file.
	{ 
		list($DistributorCode[],$DistributorName[],$Region[],$Territory[]) = explode(",",$EachLine);
	}

	
	if(strtoupper(trim($DistributorCode[0]))!=strtoupper('DistributorCode') || strtoupper(trim($DistributorName[0]))!=strtoupper('DistributorName') || strtoupper(trim($Region[0]))!=strtoupper('Region') || strtoupper(trim($Territory[0]))!=strtoupper('Territory'))
	{
		$DistributorTempRecID 		= '0';
		$CSVRowNo 					= '1';
		$Error 						= 'Invalid Column Header';
		InsertError($DistributorTempRecID,$CSVRowNo,$Error);
	}
	
	
	//Less than 2 rows present
	if($CountRows<1)
	{
		$DistributorTempRecID 		= '0';
		$CSVRowNo 					= '0';
		$Error 						= 'No Records Present';
		InsertError($DistributorTempRecID,$CSVRowNo,$Error);
	}
}

//*************************************************************
//Check for errors
$CheckErrors = "SELECT COUNT(*) AS CountErr FROM distributor_error";
$CE = $pdo->prepare($CheckErrors);
$CE->execute();
$CEDS		= $CE->fetch();
$CECount 	= $CEDS['CountErr'];

if($CECount>0)//1st If start
{
	DownloadErrorFile();
}
else //1st else If
{
	//CSV data is correct. 
	$TruncateErrTableQry = "TRUNCATE TABLE distributor_error";
	$TET = $pdo->prepare($TruncateErrTableQry);
	$TET->execute();
	
	//Insert data into dummy table for validations
	$csv_file = $TMPFilePath;
	
	$CsvFilepath = $filelocation.$NextPgUpPath;
	$UploadDataQueryTxt = "SET @position :=1; 
						   LOAD DATA LOCAL INFILE '$CsvFilepath' INTO TABLE distributor_tmp		
							   FIELDS TERMINATED BY ',' 
							   OPTIONALLY ENCLOSED BY '\"'
							   LINES TERMINATED BY '\r\n' 							   
							   IGNORE 1 LINES(DistributorCode,DistributorName,Region,Territory)
							   SET RowNo=(@position := @position + 1),CSVFilePath=:FilePath,UserRecID=:UserRecID";
	
			
	$seq = $pdo->prepare($UploadDataQueryTxt);
	$seq->bindValue('FilePath',$NextPgUpPath);
	$seq->bindValue('UserRecID',$LoggedInUser);
	$seq->execute();
	$seq->closeCursor();
	
	$UpdateDisti=$pdo->prepare("UPDATE distributor_tmp SET DistributorCode=TRIM(DistributorCode),
                                DistributorName=TRIM(DistributorName),Region=TRIM(Region),Territory=TRIM(Territory) ");
    $UpdateDisti->execute();
	
	//Validation
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//1. Distributor Code
	//a) Cannot be blank
	$CheckDistCodeIfBlank = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
												SELECT RecID,RowNo,'Distributor Code is blank' 
												FROM distributor_tmp 
												WHERE DistributorCode=''");
	$CheckDistCodeIfBlank->execute();
	
	/*//b) Alpha Numeric , allow -
	$CheckDistCodeInputChar = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
												SELECT RecID,RowNo,'Only alphabets,numbers and - (hyphen) allowed in Distributor Code' 
												FROM distributor_tmp 
												WHERE DistributorCode!='' AND DistributorCode NOT REGEXP '^[a-zA-Z0-9-]*$'");
	$CheckDistCodeInputChar->execute();*/
	
	//c) Should be unique within the file															
	$CheckDuplicateDistCodeInFile = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
													SELECT RecID,RowNo,'Duplicate Distributor Code' 
													FROM distributor_tmp
													INNER JOIN (SELECT DistributorCode
																	FROM distributor_tmp
																	GROUP BY DistributorCode
																	HAVING COUNT(*) > 1
																) dup
													ON distributor_tmp.DistributorCode = dup.DistributorCode
													WHERE distributor_tmp.RowNo NOT IN (SELECT RowNo
																	FROM distributor_tmp
																	GROUP BY DistributorCode
																	HAVING COUNT(*) > 1)");
	$CheckDuplicateDistCodeInFile->execute();
	
	//d) Should be unique in master
	$CheckAlreadyPresentDistCodeInDist = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
															SELECT RecID,RowNo,'Distributor Code already present' 
															FROM distributor_tmp
															WHERE DistributorCode!=''
															AND DistributorCode IN(SELECT DistributorCode FROM distributor)");
	$CheckAlreadyPresentDistCodeInDist->execute();
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	//2. Distributor Name
	//a) Cannot be blank
	$CheckDistNameIfBlank = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
												SELECT RecID,RowNo,'Distributor Name is blank' 
												FROM distributor_tmp 
												WHERE DistributorName=''");
	$CheckDistNameIfBlank->execute();
	
	//b) Alphabets and special char
	/*$CheckDistNameInputChar = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
												SELECT RecID,RowNo,'Only alphabets and (-+/*\><:()) characters allowed in Distributor Name' 
												FROM distributor_tmp 
												WHERE DistributorName!='' AND DistributorName NOT REGEXP '^[a-zA-Z -+/*\><:()]*$'");
	$CheckDistNameInputChar->execute();*/
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	//3. Region
	//a) Cannot be blank
	$CheckRegionIfBlank = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
												SELECT RecID,RowNo,'Region is blank' 
												FROM distributor_tmp 
												WHERE Region=''");
	$CheckRegionIfBlank->execute();
	
	//b) Alphabets 
	$CheckRegionInputChar = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
												SELECT RecID,RowNo,'Only alphabets allowed in Region' 
												FROM distributor_tmp 
												WHERE Region!='' AND Region NOT REGEXP '^[a-zA-Z]*$'");
	$CheckRegionInputChar->execute();
	
	//c) should be valid from master
	$CheckRegionValidInRegion = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
													SELECT RecID,RowNo,'Invalid Region' 
													FROM distributor_tmp 
													WHERE Region!='' AND Region NOT IN (SELECT RegionName FROM region WHERE Active=1)");
	$CheckRegionValidInRegion->execute();
    
    
    //Update Region RecID in Tmp table
	$UpdateRegionRecIDInTmp	= $pdo->prepare("UPDATE distributor_tmp dt
												INNER JOIN
												(
													SELECT RecID,RegionName FROM region WHERE Active=1
												) X ON X.RegionName=dt.Region
												SET dt.RegionRecID=X.RecID");
	$UpdateRegionRecIDInTmp->execute();
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	//4. Territory
	//a) Cannot be blank
	/*$CheckTerritoryIfBlank = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
												SELECT RecID,RowNo,'Territory is blank' 
												FROM distributor_tmp 
												WHERE Territory=''");
	$CheckTerritoryIfBlank->execute();*///made optional
	
	//b) Alphabets
	/*$CheckTerritoryInputChar = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
												SELECT RecID,RowNo,'Only alphabets, numbers and /*-+\.()@ characters allowed in Territory' 
												FROM distributor_tmp 
												WHERE Territory!='' AND Territory NOT REGEXP '^[a-zA-Z0-9 /*--_+\.()@]*$'");
	$CheckTerritoryInputChar->execute();*/
	
	//c) Should be valid from master																					
	$CheckTerritoryValidInRegionTerritory = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
																SELECT RecID,RowNo,'Invalid Territory' 
																FROM distributor_tmp 
																WHERE Territory!=''
																AND RecID NOT IN(SELECT dt.RecID FROM distributor_tmp dt,region_territory rt
																					WHERE rt.TerritoryName=dt.Territory and rt.RegionRecID=dt.RegionRecID AND Active=1)");																			
	$CheckTerritoryValidInRegionTerritory->execute();
    
    
    $UpdateTerritporyRecIDInTmp	= $pdo->prepare("UPDATE distributor_tmp dt
												INNER JOIN
												(
													SELECT RecID,TerritoryName, RegionRecID FROM region_territory WHERE Active=1 
												) X ON X.RegionRecID=dt.RegionRecID AND X.TerritoryName=dt.Territory
												SET dt.TerritoryRecID=X.RecID");
	$UpdateTerritporyRecIDInTmp->execute();
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	/*
	//5. Active
	//a) Cannot be blank
	$CheckActiveIfBlank = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
												SELECT RecID,RowNo,'Active is blank' 
												FROM distributor_tmp 
												WHERE Active=''");
	$CheckActiveIfBlank->execute();
	
	//b) Y\N
	$CheckActiveInputChar = $pdo->prepare("INSERT INTO distributor_error(DistributorTempRecID,CSVRowNo,Error)
												SELECT RecID,RowNo,'Only Y or N allowed in Active' 
												FROM distributor_tmp 
												WHERE Active!='' AND Active NOT IN ('Y','N')");
	$CheckActiveInputChar->execute();*/
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	//Check if any error exist
	
	$CheckErrors = "SELECT COUNT(*) AS CountErr FROM distributor_error";
	$CE = $pdo->prepare($CheckErrors);
	$CE->execute();
	$CEDS		= $CE->fetch();
	$CECount 	= $CEDS['CountErr'];
	
	if($CECount>0)//1st If start
	{
		DownloadErrorFile();
	}
	else 
	{
		//,CASE Active WHEN 'Y' THEN '1' WHEN 'N' THEN '0' END AS ActiveStatus
		
		//Insert Record in Distributor table
		$InsertIntoDistributor = $pdo->prepare("INSERT INTO distributor(DistributorCode,DistributorName,RegionRecID,TerritoryRecID,Active)
													SELECT dt.DistributorCode,dt.DistributorName,dt.RegionRecID,dt.TerritoryRecID,1
														FROM distributor_tmp dt");
		$InsertIntoDistributor->execute();
		
		header("Location:DistributorUploadSuccess.php");	
	}
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------	
}//Else of 1st If End

?>