<?php
/*------------------------------------------------------------------------------------------------------------------------------------------
Sr.No.	Date 			Changed By 		Description
--------------------------------------------------------------------------------------------------------------------------------------------*/
$TruncateErrTableQry = "TRUNCATE TABLE product_error";
$TET = $pdo->prepare($TruncateErrTableQry);
$TET->execute();

$TruncateErr1TableQry = "TRUNCATE TABLE product_tmp";
$TET1 = $pdo->prepare($TruncateErr1TableQry);
$TET1->execute();

$CSVDataArray=file($TMPFilePath);
$Count=0;
$ErrorLogArray=[];
foreach($CSVDataArray as $filearray)
{
	$Count++;
}
$CountRows = $Count-1;

function InsertError($ProductTmpRecID,$RowNo,$Error)
{
	$pdo = Database::connect();
	$InsertError = "INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
						VALUES(:ProductTmpRecID,:RowNo,:Error)";
	$IE = $pdo->prepare($InsertError);
	$IE->bindValue('ProductTmpRecID',$ProductTmpRecID);
	$IE->bindValue('RowNo',$RowNo);
	$IE->bindValue('Error',$Error);
	$IE->execute();
}

function DownloadErrorFile()
{
	$pdo = Database::connect();
	$SelectError = "SELECT RowNo AS 'ROW NO.',Error AS 'ERROR'
						FROM product_error";
	$SE = $pdo->prepare($SelectError);
	$SE->execute();
	
	$SelectErrorCount = "SELECT Count(*) AS ErrorCount FROM product_error";
	$SErr = $pdo->prepare($SelectErrorCount);
	$SErr->execute();
	$SErrDS	= $SErr->fetch();
	$SErowCount 	= $SErrDS['ErrorCount'];
	$SEcolumnCount 	= 2;
	
	$output='';
	$output.=',';
	$output.="ERROR LOG";
	$output.="\n\n";
	
	// Get The Field Name
	$output .="SR.NO.,";
	for ($i = 0; $i < $SEcolumnCount; $i++)
	{
		$heading = $SE->getColumnMeta($i);
		$output .= '"'.$heading['name'].'",';
	}
	$output .="\n";
	
	// Get Records from the table
	for($j=0; $j<$SErowCount; $j++)
	{
		$output.=($j+1).",";
		$row = $SE->fetch();												   										   
		for ($i = 0; $i < $SEcolumnCount; $i++) 
		{
			if(($i==0) && ($row["$i"]==0))//row no
			{
				$output .=' - ,';
			}
			else
			{
				$output .='"'.$row["$i"].'",';
			}	
		}
		$output .="\n";	
	}
	
	$datetime=date("Y-m-d His");	
	//Generate CSV file											 
	$filename = "Product_Error_Log".$datetime.".csv";
	file_put_contents("../../UPLOADS/Product/ERROR_LOGS/" . $filename,$output);
	$FilePath1='../../UPLOADS/Product/ERROR_LOGS/'.$filename;
	header("Location:$FilePath1");
	unlink($TMPFilePath);
}

$CheckOtherErr = 1;
$EachLine 	= $CSVDataArray[0];
$Arr		= explode(",",$EachLine);
$numcols 	= count($Arr); //Header Row

if($numcols!=12)
{
	$CheckOtherErr 			= 0;
	$ProductTmpRecID 		= '0';
	$RowNo 					= '-';
	$Error 					= 'Invalid No. Of Columns';
	InsertError($ProductTmpRecID,$RowNo,$Error);
	
	DownloadErrorFile();
}


if($CheckOtherErr==1)
{
	foreach($CSVDataArray as $EachLine)//Check this before adding or deleting columns in csv file.
	{ 
		list($ProductCode[],$ProductName[],$ProductGroup[],$Company[],$Rate[],$MRP[],$NR[],$UOM[],$ProductManager[],$Volume[],$VolumeUnitOfMeasure[],$TargetPercentage[]) = explode(",",$EachLine);
	}

	
	if(strtoupper(trim($ProductCode[0]))!=strtoupper('ProductCode') || strtoupper(trim($ProductName[0]))!=strtoupper('ProductName') || strtoupper(trim($ProductGroup[0]))!=strtoupper('ProductGroup') || strtoupper(trim($Company[0]))!=strtoupper('CompanyUnit') || strtoupper(trim($Rate[0]))!=strtoupper('OperatingRate') || strtoupper(trim($MRP[0]))!=strtoupper('MRP') || strtoupper(trim($NR[0]))!=strtoupper('NR') || strtoupper(trim($UOM[0]))!=strtoupper('UOM') || strtoupper(trim($ProductManager[0]))!=strtoupper('ProductManager') || strtoupper(trim($Volume[0]))!=strtoupper('Volume') || strtoupper(trim($VolumeUnitOfMeasure[0]))!=strtoupper('VolumeUnitOfMeasure') || strtoupper(trim($TargetPercentage[0]))!=strtoupper('TargetPercentage'))
	{
		$ProductTmpRecID 		= '0';
		$RowNo 					= '1';
		$Error 					= 'Invalid Column Header';
		InsertError($ProductTmpRecID,$RowNo,$Error);
	}
	
	
	//Less than 2 rows present
	if($CountRows<1)
	{
		$ProductTmpRecID 		= '0';
		$RowNo 					= '0';
		$Error 					= 'No Records Present';
		InsertError($ProductTmpRecID,$RowNo,$Error);
	}
}

//*************************************************************
//Check for errors
$CheckErrors = "SELECT COUNT(*) AS CountErr FROM product_error";
$CE = $pdo->prepare($CheckErrors);
$CE->execute();
$CEDS		= $CE->fetch();
$CECount 	= $CEDS['CountErr'];

if($CECount>0)//1st If start
{
	DownloadErrorFile();
}
else //1st else If
{
	//CSV data is correct. 
	$TruncateErrTableQry = "TRUNCATE TABLE product_error";
	$TET = $pdo->prepare($TruncateErrTableQry);
	$TET->execute();
	
	//Insert data into dummy table for validations
	$csv_file = $TMPFilePath;
	
	$CsvFilepath = $filelocation.$NextPgUpPath;
	$UploadDataQueryTxt = "SET @position :=1; 
						   LOAD DATA LOCAL INFILE '$CsvFilepath' INTO TABLE product_tmp		
							   FIELDS TERMINATED BY ',' 
							   OPTIONALLY ENCLOSED BY '\"'
							   LINES TERMINATED BY '\r\n' 							   
							   IGNORE 1 LINES(ProductCode,ProductName,ProductGroup,Company,Rate,MRP,NR,UOM,ProductManager,Volume,VolumeUnitOfMeasure,TargetPercentage)
							   SET RowNo=(@position := @position + 1),CSVFilePath=:FilePath,UserRecID=:UserRecID";
	
			
	$seq = $pdo->prepare($UploadDataQueryTxt);
	$seq->bindValue('FilePath',$NextPgUpPath);
	$seq->bindValue('UserRecID',$LoggedInUser);
	$seq->execute();
	$seq->closeCursor();
	
	
	//Check validations
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//1. Product Code
	//a) Cannot be blank
	$CheckProductCodeIfBlank = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Product Code is blank'
													FROM product_tmp
													WHERE ProductCode=''");
	$CheckProductCodeIfBlank->execute();
	
	//b) Alpha numeric, special char(
	$CheckProductCodeInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Only alphabets, numbers and (+-/\) characters allowed in Product Code'
													FROM product_tmp
													WHERE ProductCode!='' AND ProductCode NOT REGEXP '^[a-zA-Z0-9+--\/]*$'");
	$CheckProductCodeInputChar->execute();
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//2. Product Name
	//a) Cannot be blank
	$CheckProductNameIfBlank = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Product Name is blank'
													FROM product_tmp
													WHERE ProductName=''");
	$CheckProductNameIfBlank->execute();
	
	//b) Alpha numeric and Special char
/*	$CheckProductNameInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Only alphabets, numbers and (-+/*\><:.()) characters allowed in Product Name'
													FROM product_tmp
													WHERE ProductName!='' AND ProductName NOT REGEXP '^[a-zA-Z0-9 --+/*\><:.()]*$'");
	$CheckProductNameInputChar->execute();*/
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//3. Product Group
	//a) Cannot be blank
	$CheckProductGroupIfBlank = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Product Group is blank'
													FROM product_tmp
													WHERE ProductGroup=''");
	$CheckProductGroupIfBlank->execute();
	
	//b) Alphabets
	$CheckProductGroupInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Only alphabets allowed in Product Group'
													FROM product_tmp
													WHERE ProductGroup!='' AND ProductGroup NOT REGEXP '^[a-zA-Z ]*$'");
	$CheckProductGroupInputChar->execute();
	
	//c) Valid
	$CheckProductGroupIfValid = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Invalid Product Group'
													FROM product_tmp
													WHERE ProductGroup!='' AND ProductGroup NOT IN(SELECT ProductGroup FROM product_group)");
	$CheckProductGroupIfValid->execute();
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//4. Company
	//a) Cannot be blank
	$CheckCompanyIfBlank = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
												SELECT RecID,RowNo,'Company Unit is blank'
												FROM product_tmp
												WHERE Company=''");
	$CheckCompanyIfBlank->execute();
	
	//b) Alphabets 
	$CheckCompanyInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
												SELECT RecID,RowNo,'Only alphabets allowed in Company Unit'
												FROM product_tmp
												WHERE Company!='' AND Company NOT REGEXP '^[a-zA-Z]*$'");
	$CheckCompanyInputChar->execute();
	
	//c) valid 
	$CheckcompanyIfValid = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
												SELECT RecID,RowNo,'Invalid Company Unit'
												FROM product_tmp
												WHERE Company!='' AND Company NOT IN(SELECT CompanyName FROM company)");
	$CheckcompanyIfValid->execute();
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//5. Operating Rate
	//a) Cannot be blank
	$CheckRateIfBlank = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
											SELECT RecID,RowNo,'Operating Rate is blank'
											FROM product_tmp
											WHERE Rate=''");
	$CheckRateIfBlank->execute();
	
	//b) decimal numbers
	$CheckRateInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
											SELECT RecID,RowNo,'Only numbers allowed in Operating Rate'
											FROM product_tmp
											WHERE Rate!='' AND Rate NOT REGEXP '^[0-9.]*$'");
	$CheckRateInputChar->execute();
	
	//c) valid number
	$CheckRateIfValidNumber = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
												SELECT RecID,RowNo,'Invalid Operating Rate'
												FROM product_tmp
												WHERE Rate!='' AND (LENGTH(Rate)-LENGTH(REPLACE(Rate,'.','')))>1");
	
	//d) Number greater than zero
	$CheckRateIfGreaterDnZero = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Operating Rate should be greater than zero'
													FROM product_tmp
													WHERE Rate!='' AND Rate<=0");
	$CheckRateIfGreaterDnZero->execute();
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//6. MRP
	//a) Cannot be blank
/*	$CheckMRPIfBlank = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
											SELECT RecID,RowNo,'MRP is blank'
											FROM product_tmp
											WHERE MRP=''");
	$CheckMRPIfBlank->execute();*/
	
	//b) decimal numbers
	$CheckMRPInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
											SELECT RecID,RowNo,'Only numbers allowed in MRP'
											FROM product_tmp
											WHERE MRP!='' AND MRP NOT REGEXP '^[0-9.]*$'");
	$CheckMRPInputChar->execute();
	
	//c Valid number
	$CheckMRPIfValifNumber = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
												SELECT RecID,RowNo,'Invalid MRP'
												FROM product_tmp
												WHERE MRP!='' AND (LENGTH(MRP)-LENGTH(REPLACE(MRP,'.','')))>1");
	$CheckMRPIfValifNumber->execute();
	
	//d) Number greater than zero
	$CheckMRPIfGreaterDnZero = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
												SELECT RecID,RowNo,'MRP should be greater than zero'
												FROM product_tmp
												WHERE MRP!='' AND MRP<=0");
	$CheckMRPIfGreaterDnZero->execute();
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//7. NR
	//a) Cannot be blank
/*	$CheckNRIfBlank = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
											SELECT RecID,RowNo,'NR is blank'
											FROM product_tmp
											WHERE NR=''");
	$CheckNRIfBlank->execute();*/
	
	//b) decimal numbers
	$CheckNRInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
											SELECT RecID,RowNo,'Only numbers allowed in NR'
											FROM product_tmp
											WHERE NR!='' AND NR NOT REGEXP '^[0-9.]*$'");
	$CheckNRInputChar->execute();
	
	//c Valid number
	$CheckNRIfValifNumber = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
												SELECT RecID,RowNo,'Invalid NR'
												FROM product_tmp
												WHERE NR!='' AND (LENGTH(NR)-LENGTH(REPLACE(NR,'.','')))>1");
	$CheckNRIfValifNumber->execute();
	
	//d) Number greater than zero
	$CheckNRIfGreaterDnZero = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
												SELECT RecID,RowNo,'NR should be greater than zero'
												FROM product_tmp
												WHERE NR!='' AND NR<=0");
	$CheckNRIfGreaterDnZero->execute();
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//8. UOM
	//a) Cannot be blank
	/*$CheckUOMIfBlank = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
											SELECT RecID,RowNo,'UOM is blank'
											FROM product_tmp
											WHERE UOM=''");
	$CheckUOMIfBlank->execute();*/
	
	//b) Alphabets
	$CheckUOMInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
											SELECT RecID,RowNo,'Only alphabets allowed in UOM'
											FROM product_tmp
											WHERE UOM!='' AND UOM NOT REGEXP '^[a-zA-Z]*$'");
	$CheckUOMInputChar->execute();
	
	//c) valid
	$CheckUOMIfValid = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
											SELECT RecID,RowNo,'Invalid UOM'
											FROM product_tmp
											WHERE UOM!='' AND UOM NOT IN(SELECT Abbrevation FROM uom)");
	$CheckUOMIfValid->execute();
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//9. Product Manager
	//a) Cannot be blank
	/*$CheckProductManagerIfBlank = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
														SELECT RecID,RowNo,'Product Manager is blank'
														FROM product_tmp
														WHERE ProductManager=''");
	$CheckProductManagerIfBlank->execute();*/
	
	//b) Alphabets
	$CheckProductManagerInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
														SELECT RecID,RowNo,'Only alphabets allowed in Product Manager'
														FROM product_tmp
														WHERE ProductManager!='' AND ProductManager NOT REGEXP '^[a-zA-Z ]*$'");
	$CheckProductManagerInputChar->execute();
	
	//c) valid
	$CheckProductManagerIfValid = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
														SELECT RecID,RowNo,'Invalid Product Manager'
														FROM product_tmp
														WHERE ProductManager!='' AND ProductManager NOT IN(SELECT EmployeeName FROM employee 
																												WHERE DesignationRecID=6 AND Active=1)");
	$CheckProductManagerIfValid->execute();
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//10. Volume
	//a) Cannot be blank
	/*$CheckVolumeIfBlank = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
												SELECT RecID,RowNo,'Volume is blank'
												FROM product_tmp
												WHERE Volume=''");
	$CheckVolumeIfBlank->execute();*/
	
	//b) decimal
	$CheckVolumeInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
												SELECT RecID,RowNo,'Only numbers allowed in Volume'
												FROM product_tmp
												WHERE Volume!='' AND Volume NOT REGEXP '^[0-9.]*$'");
	$CheckVolumeInputChar->execute();
	
	//c) Valid Number
	$CheckVolumeIfValidNumber = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Invalid Volume'
													FROM product_tmp
													WHERE Volume!='' AND (LENGTH(Volume)-LENGTH(REPLACE(Volume,'.','')))>1");
	$CheckVolumeIfValidNumber->execute();
	
	//d) Number greater than zero
	$CheckVolumeIfGreaterDnZero = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Volume should be greater than zero'
													FROM product_tmp
													WHERE Volume!='' AND Volume<=0");
	$CheckVolumeIfGreaterDnZero->execute();
	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
	//11. Volume UOM
	//a) cannot be blank
/*	$CheckVolumeUOMIfBlank = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Volume Unit Of Measure is blank'
													FROM product_tmp
													WHERE VolumeUnitOfMeasure=''");
	$CheckVolumeUOMIfBlank->execute();*/
	
	//b) Alphabets
	$CheckVolumeUOMInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Only alphabets allowed in Volume Unit Of Measure'
													FROM product_tmp
													WHERE VolumeUnitOfMeasure!='' AND VolumeUnitOfMeasure NOT REGEXP '^[a-zA-Z]*$'");
	$CheckVolumeUOMInputChar->execute();
	
	//c) Valid Volume UOM
	$CheckVolumeUOMIfValid = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
													SELECT RecID,RowNo,'Invalid Volume Unit Of Measure'
													FROM product_tmp
													WHERE VolumeUnitOfMeasure!='' AND VolumeUnitOfMeasure NOT IN(SELECT Abbrevation FROM uom)");
	$CheckVolumeUOMIfValid->execute();
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	//12. Target Percentage
	
	//a) decimal numbers
	$CheckTargetPercentageInputChar = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
														SELECT RecID,RowNo,'Only numbers allowed in Target Percentage'
														FROM product_tmp
														WHERE TargetPercentage!='' AND TargetPercentage NOT REGEXP '^[0-9.]*$'");
	$CheckTargetPercentageInputChar->execute();
	
	//b) valid number
	$CheckTargetPercentageIfValidNumber = $pdo->prepare("INSERT INTO product_error(ProductTmpRecID,RowNo,Error)
															SELECT RecID,RowNo,'Invalid Target Percentage'
															FROM product_tmp
															WHERE TargetPercentage!='' AND (LENGTH(TargetPercentage)-LENGTH(REPLACE(TargetPercentage,'.','')))>1");

	
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	
	//Check if any error exist
	
	$CheckErrors = "SELECT COUNT(*) AS CountErr FROM product_error";
	$CE = $pdo->prepare($CheckErrors);
	$CE->execute();
	$CEDS		= $CE->fetch();
	$CECount 	= $CEDS['CountErr'];
	
	if($CECount>0)//1st If start
	{
		DownloadErrorFile();
	}
	else 
	{
		//Call Procedure
		$Call_Proc = $pdo->prepare("CALL ProductUploadInsertUpdate()");
		$Call_Proc->execute();
		
		header("Location:ProductUploadSuccess.php");
	/*
		//If product code already present, update rest of the fields else insert a record in product table. 
		$SelectTMPData = $pdo->prepare("SELECT pt.ProductCode,pt.ProductName,pt.ProductGroup,pt.Company,pt.Rate,pt.NR,pt.MRP,pt.UOM,pt.ProductManager,
											pg.RecID AS PGRecID,c.RecID AS CRecID,uom.RecID AS URecID,e.RecID AS ERecID
											FROM product_tmp pt
											LEFT JOIN product_group pg ON pg.ProductGroup=pt.ProductGroup
											LEFT JOIN company c ON c.CompanyName=pt.Company
											LEFT JOIN uom ON uom.UnitOfMeasure=pt.UOM
											LEFT JOIN employee e ON e.EmployeeName=pt.ProductManager");
		$SelectTMPData->execute();
		$SelectTMPDataDS = $SelectTMPData->fetchAll();
		foreach($SelectTMPDataDS as $data)
		{
			$ProductCode	= $data['ProductCode'];
			$ProductName	= $data['ProductName'];
			$Rate			= $data['Rate'];
			$NR				= $data['NR'];
			$MRP			= $data['MRP'];
			$PGRecID		= $data['PGRecID'];
			$CRecID			= $data['CRecID'];
			$URecID			= $data['URecID'];
			$ERecID			= $data['ERecID'];
			
			//Check if Product code already exist. If yes, update record. Else insert record in product table.
			$CheckProductExistence = $pdo->prepare("SELECT COUNT(*) AS ProductExistCount,RecID FROM product
														WHERE ProductCode=:ProductCode");
			$CheckProductExistence->bindValue('ProductCode',$ProductCode);
			$CheckProductExistence->execute();
			$CheckProductExistenceDS 	= $CheckProductExistence->fetch();
			$ProductExistCount 			= $CheckProductExistenceDS['ProductExistCount'];
			$ProdRecID					= $CheckProductExistenceDS['RecID'];
			
			if($ProductExistCount<=0) // Insert
			{
				$InsertProduct = $pdo->prepare("INSERT INTO product(ProductCode,ProductName,ProductGroupRecID,CompanyRecID,Rate,NR,MRP,UOMRecID,ProductManagerRecID)
													VALUES(:ProductCode,:ProductName,:ProductGroupRecID,:CompanyRecID,:Rate,:NR,:MRP,:UOMRecID,:ProductManagerRecID)");
				$InsertProduct->bindValue('ProductCode',$ProductCode);
				$InsertProduct->bindValue('ProductName',$ProductName);
				$InsertProduct->bindValue('ProductGroupRecID',$PGRecID);
				$InsertProduct->bindValue('CompanyRecID',$CRecID);
				$InsertProduct->bindValue('Rate',$Rate);
				$InsertProduct->bindValue('NR',$NR);
				$InsertProduct->bindValue('MRP',$MRP);
				$InsertProduct->bindValue('UOMRecID',$URecID);
				$InsertProduct->bindValue('ProductManagerRecID',$ERecID);
				$InsertProduct->execute();
			}
			else //Update
			{
				$UpdateProduct = $pdo->prepare("UPDATE product SET Rate=:Rate,NR=:NR,MRP=:MRP,ProductManagerRecID=:ProductManagerRecID
													WHERE RecID=:RecID");
				$UpdateProduct->bindValue('RecID',$ProdRecID);
				/*$UpdateProduct->bindValue('ProductName',$ProductName);
				$UpdateProduct->bindValue('ProductGroupRecID',$PGRecID);
				$UpdateProduct->bindValue('CompanyRecID',$CRecID);*/
				/*$UpdateProduct->bindValue('Rate',$Rate);
				$UpdateProduct->bindValue('NR',$NR);
				$UpdateProduct->bindValue('MRP',$MRP);
				//$UpdateProduct->bindValue('UOMRecID',$URecID);
				$UpdateProduct->bindValue('ProductManagerRecID',$ERecID);
				$UpdateProduct->execute();
			}
		
			header("Location:ProductUploadSuccess.php");
		}*/
	}
	//------------------------------------------------------------------------------------------------------------------------------------------------------------------
}//Else of 1st If End

?>