<?php
/*********************************************************************************************************************************************************************************
SrNo	Date		Name		Description
1		29/12/2018	Tejasvi		Display manual Remark below Remak without label.
**********************************************************************************************************************************************************************************/
include("../../../MPDF54/mpdf.php");
include '../../common/global.php';
include '../../common/globalrights.php';

$pdo = Database::connect();

if (!$user->is_loggedin())
	$user->redirect('../../index.php');
	
$stylesheet			= file_get_contents("../../css/FSPDFCss.css");

$RateApprovalRecID	= $_GET['RateApprovalRecID'];
$type				= $_GET['type'];

//Header Details
$SelectHeaderDetails = $pdo->prepare("SELECT TrsYearRef,TrsNo,TrsDate,RegionName,TerritoryName,RegionTerritoryHQName,EmployeeName,
											DistributorName,RateApprovalType,FormatNo,SeriesName,AuthorisationNo,RegionRefNo,ValidityDate,rah.Remark,Post,
											ManualRemark
											FROM rate_approval_header rah
											LEFT JOIN region r ON r.RecID=rah.RegionRecID
											LEFT JOIN region_territory rt ON rt.RecID=rah.TerritoryRecID
											LEFT JOIN region_territory_hq rthq ON rthq.RecID=rah.HQRecID
											LEFT JOIN employee e ON e.RecID=rah.SOEmployeeRecID
											LEFT JOIN distributor d ON d.RecID=rah.DistRecID
											LEFT JOIN rate_approval_type rat ON rat.RecID=rah.RateApprovalTypeRecID
											LEFT JOIN rate_approval_series ras ON ras.RecID=rah.RateApprovalSeriesRecID
											WHERE rah.RecID=:RecID");
$SelectHeaderDetails->bindValue('RecID',$RateApprovalRecID);
$SelectHeaderDetails->execute();
$SelectHeaderDetailsDS = $SelectHeaderDetails->fetch();
$TrsYearRef				= $SelectHeaderDetailsDS['TrsYearRef'];
$TrsNo					= $SelectHeaderDetailsDS['TrsNo'];
$TrsDate				= convertdate($SelectHeaderDetailsDS['TrsDate']);
$RegionName				= $SelectHeaderDetailsDS['RegionName'];
$TerritoryName			= $SelectHeaderDetailsDS['TerritoryName'];
$RegionTerritoryHQName	= $SelectHeaderDetailsDS['RegionTerritoryHQName'];
$EmployeeName			= $SelectHeaderDetailsDS['EmployeeName'];
$DistributorName		= $SelectHeaderDetailsDS['DistributorName'];
$RateApprovalType		= $SelectHeaderDetailsDS['RateApprovalType'];
$FormatNo				= $SelectHeaderDetailsDS['FormatNo'];
$SeriesName				= $SelectHeaderDetailsDS['SeriesName'];
$AuthorisationNo		= $SelectHeaderDetailsDS['AuthorisationNo'];
$RegionRefNo			= $SelectHeaderDetailsDS['RegionRefNo'];
$ValidityDate			= convertdate($SelectHeaderDetailsDS['ValidityDate']);
$Remark					= $SelectHeaderDetailsDS['Remark'];
$ManualRemark			= $SelectHeaderDetailsDS['ManualRemark'];
$Post					= $SelectHeaderDetailsDS['Post'];

if($ValidityDate=='00-00-0000')
{
	$ValidityDate = '';
}

//Check if accepted.
$CheckIfAcceptedQry = $pdo->prepare("SELECT Status
										FROM rate_approval_workflow_ch rawc
										LEFT JOIN rate_approval_header rah ON rah.RecID=rawc.RateApprovalHdRecID
										WHERE rah.RecID=:RecID AND WorkFlowRecID=4");
$CheckIfAcceptedQry->bindValue('RecID',$RateApprovalRecID);
$CheckIfAcceptedQry->execute();
$CheckIfAcceptedQryDS 	= $CheckIfAcceptedQry->fetch();
$AccStatus 				= $CheckIfAcceptedQryDS['Status'];
//===========================================================================================================================================

$html = '';

$html.='
<table width="100%" cellpadding="5px" cellspacing="3px" style="padding-top:2%; padding-left:2%; padding-right:2%">
<tr>
	<td width="15%" style="font-family:Arial;font-size:9pt;text-align:left;font-weight:bold;padding:1px 1px 1px 1px;">Trs Ref.</td>
	<td width="35%" style="font-family:Arial;font-size:9pt;text-align:left;padding:1px;">: '.$TrsYearRef.'/'.$TrsNo.' Dtd '.$TrsDate.'</td>
	<td width="20%" style="font-family:Arial;font-size:9pt;text-align:left;font-weight:bold;padding:1px 1px 1px 2px;">Authorisation No.</td>
	<td width="25%" style="font-family:Arial;padding:5px;font-size:9pt;text-align:left;padding:1px;">: '.$AuthorisationNo.'</td>
</tr>

<tr>
	<td style="font-family:Arial;font-size:9pt;text-align:left;font-weight:bold;padding:1px 1px 1px 1px;">Region</td>
	<td style="font-family:Arial;font-size:9pt;text-align:left;padding:1px;">: '.$RegionName.'</td>
	<td style="font-family:Arial;font-size:9pt;text-align:left;font-weight:bold;padding:1px 1px 1px 2px;">Branch Ref No.</td>
	<td style="font-family:Arial;padding:5px;font-size:9pt;text-align:left;padding:1px;">: '.$RegionRefNo.'</td>
</tr>

<tr>
	<td style="font-family:Arial;font-size:9pt;text-align:left;font-weight:bold;padding:1px 1px 1px 1px;">Name of Dealer</td>
	<td style="font-family:Arial;font-size:9pt;text-align:left;padding:1px;">: '.$DistributorName.'</td>
	<td style="font-family:Arial;font-size:9pt;text-align:left;font-weight:bold;padding:1px 1px 1px 2px;">Valid Till</td>
	<td style="font-family:Arial;padding:5px;font-size:9pt;text-align:left;padding:1px;">: '.$ValidityDate.'</td>
</tr>

<tr>
	<td style="font-family:Arial;font-size:9pt;text-align:left;font-weight:bold;padding:1px 1px 1px 1px;"></td>
	<td style="font-family:Arial;font-size:9pt;text-align:left;padding:1px;"> </td>
	<td style="font-family:Arial;font-size:9pt;text-align:left;font-weight:bold;padding:1px 1px 1px 2px;">Name of SO/SE/AM/ZM</td>
	<td style="font-family:Arial;padding:5px;font-size:9pt;text-align:left;padding:1px;">: '.$EmployeeName.'</td>
</tr>

<tr>
	<td style="font-family:Arial;font-size:9pt;text-align:left;font-weight:bold;padding:1px 1px 1px 1px;"></td>
	<td style="font-family:Arial;font-size:9pt;text-align:left;padding:1px;"> </td>
	<td style="font-family:Arial;font-size:9pt;text-align:left;font-weight:bold;padding:1px 1px 1px 2px;">Headquarter</td>
	<td style="font-family:Arial;padding:5px;font-size:9pt;text-align:left;padding:1px;">: '.$RegionTerritoryHQName.'</td>
</tr>
</table>

';
	

$html.='
<br><br>
<table width="100%" border="0" cellpadding="5px" cellspacing="0" style="padding-left:2%; padding-right:2%">
<thead>
<tr>
	<th width="1%" style="font-family:Arial;border-top:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;border-left:1px solid #3F3F3F;font-size:10pt;text-align:center;vertical-align:top;font-weight:bold;padding:1px 1px 1px 2px;">Sr.No.
	</th>
	<th width="14%" style="font-family:Arial;border-top:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:10pt;text-align:center;vertical-align:top;font-weight:bold;padding:1px 1px 1px 2px;">Customer
	</th>
	<th width="10%" style="font-family:Arial;border-top:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:10pt;text-align:center;vertical-align:top;font-weight:bold;padding:1px 1px 1px 2px;">Company Unit
	</th>
	<th width="22%" style="font-family:Arial;border-top:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:10pt;text-align:center;vertical-align:top;font-weight:bold;padding:1px 1px 1px 2px;">Product
	</th>
	<th width="8%" style="font-family:Arial;border-top:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:10pt;text-align:center;vertical-align:top;font-weight:bold;padding:1px 1px 1px 2px;">Avg Qty Per Month
	</th>
	<th width="8%" style="font-family:Arial;border-top:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:10pt;text-align:center;vertical-align:top;font-weight:bold;padding:1px 1px 1px 2px;">Operating Rate (Rs.)
	</th>';
	
	if($Post==0)
	{
	$html.='
	<th width="8%" style="font-family:Arial;border-top:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:10pt;text-align:center;vertical-align:top;font-weight:bold;padding:1px 1px 1px 2px;">Comp Rate Before Tax
	</th>';
	}
	
	$html.='
	<th width="8%" style="font-family:Arial;border-top:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:10pt;text-align:center;vertical-align:top;font-weight:bold;padding:1px 1px 1px 2px;">Cust Rate Before Tax
	</th>
	
	<th width="8%" style="font-family:Arial;border-top:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:10pt;text-align:center;vertical-align:top;font-weight:bold;padding:1px 1px 1px 2px;"> Disc %
	</th>
	<th width="8%" style="font-family:Arial;border-top:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:10pt;text-align:center;vertical-align:top;font-weight:bold;padding:1px 1px 1px 2px;">Dealer Rate Before Tax
	</th>';
	
	if($Post==0)
	{
	$html.='
	<th width="8%" style="font-family:Arial;border-top:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:10pt;text-align:center;vertical-align:top;font-weight:bold;padding:1px 1px 1px 2px;">Avg Value Expected
	</th>';
	}
	
	$html.='
</tr>
</thead>

<tbody>';

//Child Data
$SrNo = 1;
$SelectChildData = $pdo->prepare("SELECT CustomerName,ProductGroup,ProductName,AvgQtyPerMonth,rac.MRP,CompetitorName,CompRateBeforeTax,CustRateBeforeTax,
										DealerShareCustomerDiscPer,CurrentDealerSharePer,NewDealerDiscPer,DealerRateBeforeTax,AvgValueExpected,
										CompanyName 
										FROM rate_approval_ch rac
										LEFT JOIN customer c ON c.RecID=rac.CustomerRecID
										LEFT JOIN product_group pg ON pg.RecID=rac.ProductGroupRecID
										LEFT JOIN product p ON p.RecID=rac.ProductRecID
										LEFT JOIN company cm ON cm.RecID=p.CompanyRecID
										WHERE RateApprovalHdRecID=:RateApprovalHdRecID
										ORDER BY CustomerName,ProductGroup,ProductName");
$SelectChildData->bindvalue('RateApprovalHdRecID',$RateApprovalRecID);
$SelectChildData->execute();
$SelectChildDataDS = $SelectChildData->fetchAll();
foreach($SelectChildDataDS as $childrow)
{
	$CompanyName				= $childrow['CompanyName'];
	$CustomerName				= $childrow['CustomerName'];
	$ProductGroup				= $childrow['ProductGroup'];
	$ProductName				= $childrow['ProductName'];
	$AvgQtyPerMonth				= $childrow['AvgQtyPerMonth'];
	$MRP						= $childrow['MRP'];
	$CompetitorName				= $childrow['CompetitorName'];
	$CompRateBeforeTax			= $childrow['CompRateBeforeTax'];
	$CustRateBeforeTax			= $childrow['CustRateBeforeTax'];
	//$DealerShareCustomerDiscPer	= $childrow['DealerShareCustomerDiscPer'];
	//$CurrentDealerSharePer		= $childrow['CurrentDealerSharePer'];
	$NewDealerDiscPer			= $childrow['NewDealerDiscPer'];
	$DealerRateBeforeTax		= $childrow['DealerRateBeforeTax'];
	$AvgValueExpected 			= $childrow['AvgValueExpected'];
	
	$html.='
	<tr>
	<td style="font-family:Arial;border-left:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:center;font-weight:bold;">
	'.$SrNo.'</td>
	<td style="font-family:Arial;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:left;font-weight:bold;">'.$CustomerName.'</td>
	<td style="font-family:Arial;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:left;font-weight:bold;">'.$CompanyName.'</td>
	<td style="font-family:Arial;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:left;font-weight:bold;">'.$ProductName.'</td>
	<td style="font-family:Arial;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:right;font-weight:bold;">'.$AvgQtyPerMonth.'</td>
	<td style="font-family:Arial;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:right;font-weight:bold;">'.$MRP.'</td>';
	
	if($Post==0)
	{
	$html.='
	<td style="font-family:Arial;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:right;font-weight:bold;">'.$CompRateBeforeTax.'</td>';
	}
	
	$html.='
	<td style="font-family:Arial;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:right;font-weight:bold;">'.$CustRateBeforeTax.'</td>
	<td style="font-family:Arial;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:right;font-weight:bold;">'.$NewDealerDiscPer.'</td>
	<td style="font-family:Arial;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:right;font-weight:bold;">'.$DealerRateBeforeTax.'</td>';
	
	if($Post==0)
	{
	$html.='
	<td style="font-family:Arial;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:right;font-weight:bold;">'.$AvgValueExpected.'</td>';
	}
	
	$html.='
	</tr>
	';

$SrNo++;
}


if($Post==0)
{
	$LastColspan = 11;
}
else
{
	$LastColspan = 9;
}

if($Remark!='')
{
	$ManualRemark='<br>'.$ManualRemark;
}
$ComboRemark = $Remark.$ManualRemark;

$html.='
<tr>
	<td colspan="'.$LastColspan.'" style="font-family:Arial;border-left:1px solid #3F3F3F;border-bottom:1px solid #3F3F3F;border-right:1px solid #3F3F3F;font-size:9pt;text-align:left;font-weight:bold;">Remark : '.$ComboRemark.'</td>
</tr>
</tbody>
</table>';

//echo $html;exit;
//===========================================================================================================================================

if($AccStatus==0)
{
	$or = 'RateApproval'.$TrsYearRef.$TrsNo.date("Y-m-d His"); //filename
}
else
{
	$AuthorisationNoUpd = str_replace('/','-',$AuthorisationNo);
	$or = $AuthorisationNoUpd; //filename
}

//5.margin_left ,6.margin_right ,7.margin_top ,8.margin_bottom ,9.margin_header ,10.margin_footer 
$mpdf=new mPDF('c','A4-L','','Arial' , 5 , 5 , 20 ,10, 5 , 10);//24 3rd last for footer margin
$mpdf->debug = true;
$mpdf->SetDisplayMode('fullpage');

$mpdf->SetHTMLHeader('
<div style="border-top:1px solid #000000;border-left:1px solid #000000;border-right:1px solid #000000; border-bottom:1px solid #000000;height:100%">
<table width="100%" border="0" cellpadding="0px" cellspacing="0px" style="margin:0% 0% 0% 0%; padding:2% 2% 1% 0%;">
<tr>
	<td width="55%" style="text-align:right;font-weight:bold;font-family:Arial, Helvetica, sans-serif;font-size:18px;color:#000000;">'.$RateApprovalType.'</td>
	<td width="45%" align="right" style="font-size:14px;font-weight:bold;">Page No : {PAGENO} of {nb}</td>
</tr>

</table>');
/*
<tr>
	<td colspan="2" style="text-align:right;font-weight:400;font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#000000;">'.$FormatNo.'</td>
</tr>*/

$mpdf->list_indent_first_level = 0;  // 1 or 0 - whether to indent the first level of a list
$mpdf->WriteHTML($stylesheet,1);

$mpdf->WriteHTML($html,2);
$mpdf->SetHTMLFooter('
<center>
<table width="100%" cellpadding="0" style="margin-top:6%;padding-right:2%;padding-left:2%; padding-bottom:1%">
<tr>
	<td width="5%" style="padding-right:15px;padding-left:15px;">&nbsp;&nbsp;</td>
	<td width="15%" style="font-size:12px;text-align:center;padding-right:15px;padding-left:15px;border-top:1px solid #000000"><b>Prepared By SO/SE/AM/ZM</b></td>
	<td width="5%" style="padding-right:15px;padding-left:15px;">&nbsp;&nbsp;</td>
	<td width="15%" style="font-size:12px;text-align:center;padding-right:15px;padding-left:15px;border-top:1px solid #000000"><b>Approved By RSM</b></td>
	<td width="5%" style="padding-right:15px;padding-left:15px;">&nbsp;&nbsp;</td>
	<td width="15%" style="font-size:12px;text-align:center;padding-right:15px;padding-left:15px;border-top:1px solid #000000"><b>Authorised By GSM</b></td>
	<td width="5%" style="padding-right:15px;padding-left:15px;">&nbsp;&nbsp;</td>
</tr>

<tr>
	<td colspan="3" style="text-align:left;font-weight:400;font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#000000;"> '.$FormatNo.'</td>
	<td colspan="4" style="text-align:right;font-weight:400;font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#000000;">* '.$AuthorisationNo.'</td>
</tr>
</table>
</div>
</center>

');

$pdname=$or.".pdf"; //filepath

if($type==1)
{
	$mpdf->Output($pdname,'I');
}
else if($type==2)
{
	$mpdf->Output($pdname,'D');
}


//unlink($pdname);

?>